#include <stdio.h>
#include <stdlib.h>

void selection_sort(int a[], int length)
{
  int i;
  for (i=0; i < length; i++)
  {
    int j, v = a[i];

    for (j = i - 1; j >= 0; j--)
    {
        if (a[j] <= v) break;
        a[j + 1] = a[j];
    }
    a[j + 1] = v;

  }
}
void printarray(int a[],int len){
  int i;
  for (i=0;i<len;i++)
      printf("%d ",a[i]);
  printf("\n");
}

int main(){
    int prosegui=1;
    while (prosegui){
        int len;
        printf("Quanti numeri ordinare ? ");
        scanf("%d",&len);
        /* allocazione */
        int *array = (int *) malloc (len*sizeof(int));
        int i;
        for (i=len-1; i>=0; i--)
            array[len-i-1]=i;
        printf("Prima:\n");
        printarray(array,len);
        selection_sort(array,len);
        printf("Dopo:\n");
        printarray(array,len);
        printf("\nSi desidera proseguire ? (0 per uscire)");
        scanf("%d",&prosegui);
        if (prosegui)
           free(array); /* deallocazione */
    }
    system("PAUSE");
    return 1;
}
